> ## Documentation Index
> Fetch the complete documentation index at: https://docs.obiguard.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Image Generation

> Obiguard AI gateway enables image generation features provided by various foundational model vendors.

A typical scenario is text-to-image generation, where a user provides a prompt that the image model interprets to produce an image.

<Note>
  You can find the vision models [guide here](vision).
</Note>

### Text-to-Image Generation

Obiguard allows you to make text-to-image requests using the OpenAI-compatible API signature.

<Tabs>
  <Tab title="Python SDK">
    ```python theme={null}
    from obiguard import Obiguard

    client = Obiguard(
      provider='openai',
      base_url='https://gateway.obiguard.ai/v1',
      obiguard_api_key='vk-obg***',  # Your Obiguard virtual key here
    )

    response = client.images.generate(
      prompt="A beautiful sunset over the mountains",
      n=1,
      size="1024x1024"
    )
    ```
  </Tab>

  <Tab title="OpenAI Python">
    ```python theme={null}
    from openai import OpenAI
    from obiguard import createHeaders

    client = OpenAI(
      base_url='https://gateway.obiguard.ai/v1',
      api_key='sk-***',  # Your OpenAI API key here
      default_headers=createHeaders(
        provider="openai",
        api_key="vk-obg***",  # Your Obiguard virtual key here
      )
    )

    response = client.images.generate(
      prompt="A beautiful sunset over the mountains",
      n=1,
      size="1024x1024"
    )
    ```
  </Tab>

  <Tab title="cURL">
    ```curl theme={null}
    curl "https://gateway.obiguard.ai/v1/images/generations" \
    -H "Content-Type: application/json" \
    -H "x-obiguard-api-key: $OBIGUARD_VIRTUAL_KEY" \
    -d '{
      "model": "dall-e-3",
      "prompt": "Lucy in the sky with diamonds"
    }'
    ```
  </Tab>
</Tabs>
